#ifndef MF3DIOCALLBACK_H
#define	MF3DIOCALLBACK_H
/*==============================================================================
 *
 *	File:		MFIOCALL.H
 *
 *	Function:	File I/O Callback Routines
 *
 *	Author(s):	Rick Wong (RWW)
 *
 *	Copyright:	(c) 1995 by Apple Computer, Inc., all rights reserved.
 *
 *	Change History (most recent first):
 *		Fabio	Changed file name to 8 characters
 *		F29_RWW	File created.
 *==============================================================================
 */

#if defined(__COMPILING_ON_MACINTOSH__)
#pragma once
#endif

#include "MFTYPES.H"

/*==============================================================================
 *	If you are unable to use MF3DOpenInputStdCFile and MF3DOpenOutputStdCFile,
 *	MF3DOpenInput and MF3DOpenOutput require an MF3DProcsPtr which define
 *	six basic I/O routines. You must define the six routines and include
 *	them in an MF3DProcsRec in your call to MF3DOpen.
 *==============================================================================
 */

typedef	MF3DErr		(*MF3DOpenProcPtr)(MF3DDataFormatEnum, MF3DUserOpenDataPtr,
							MF3DUserFilePtr *);
typedef	MF3DErr		(*MF3DReadProcPtr)(MF3DUserFilePtr, MF3DSize, char *);
typedef	MF3DErr		(*MF3DWriteProcPtr)(MF3DUserFilePtr, MF3DSize, const char *);
typedef	MF3DErr		(*MF3DTellProcPtr)(MF3DUserFilePtr, MF3DBinaryFilePosition *);
typedef	MF3DErr		(*MF3DSeekProcPtr)(MF3DUserFilePtr, MF3DBinaryFilePosition);
typedef	MF3DErr		(*MF3DCloseProcPtr)(MF3DUserFilePtr);

typedef struct MF3DProcsRec
{	MF3DOpenProcPtr		openProc;
	MF3DReadProcPtr		readProc;
	MF3DWriteProcPtr	writeProc;
	MF3DTellProcPtr		tellProc;
	MF3DSeekProcPtr		seekProc;
	MF3DCloseProcPtr	closeProc;
} MF3DProcsRec, *MF3DProcsPtr;

#endif
