/******************************************************************************
 **																			 **
 ** 	Module:		TtBitmap.c												 **
 ** 																		 **
 ** 	Purpose: 	Empty rasterizer drawing engine.						 **
 ** 				Methods for drawing bitmaps.							 **
 ** 																		 **
 ** 	Author:		Mike W. Kelley											 **
 ** 																		 **
 **					2/3/95	Revised for 0.9 SDK release						 **
 ** 																		 **
 ** 	Copyright (C) 1994-95 Apple Computer, Inc.  All rights reserved.	 **
 ** 	Apple Computer Confidential											 **
 ** 																		 **
 *****************************************************************************/

#include "Drive3D.h"
#include "Drive3D_system.h"
#include "TtTinselTown.h"

/************************************************************************************************
 * Draw a bitmap.
 ***********************************************************************************************/

void TtDrawBitmap (
	const TQADrawContext	*drawContext,		/* Draw context */
	const TQAVGouraud 	*v,					/* xyz, and (if a 1 bit/pixel bitmap) argb */
	TQABitmap			*bitmap)			/* Previously allocated by QABitmapNew() */
{
	TTtDrawPrivate		*myPrivate;
	TTtBitmap			*myBitmap;
	
	myPrivate = (TTtDrawPrivate *) drawContext->drawPrivate;
	myBitmap = (TTtBitmap *) bitmap;
}
