/******************************************************************************
 **																			 **
 ** 	Module:		TtBitmapStore.c											 **
 ** 																		 **
 ** 	Purpose: 	Empty rasterizer drawing engine.						 **
 ** 				Methods for bitmap New, Detach and Delete.				 **
 ** 																		 **
 ** 	Author:		Mike W. Kelley											 **
 ** 																		 **
 **					2/3/95	Revised for 0.9 SDK release						 **
 ** 																		 **
 ** 	Copyright (C) 1994-95 Apple Computer, Inc.  All rights reserved.	 **
 ** 	Apple Computer Confidential											 **
 ** 																		 **
 *****************************************************************************/

/* System */
#include <stdlib.h>
#include <math.h>

#include "Drive3D.h"
#include "Drive3D_system.h"
#include "TtTinselTown.h"

/**************************************************************************************
 * Allocate a bitmap.
 *************************************************************************************/

TQAError TtBitmapNew (
	unsigned long		flags,				/* Mask of kQABitmap_xxx flags */
	TQAImagePixelType	pixelType,			/* Depth, color space, etc. */
	const TQAImage		*image,				/* Image */
	TQABitmap			**newBitmap)		/* (Out) Newly created TQABitmap, or NULL on error */ 
{
	/*
	 * Allocate new bitmap memory, and assign new bitmap pointer to 'newBitmap'.
	 * For now we assign NULL and return an error (as this function isn't
	 * yet implemented).
	 */
	
	*newBitmap = NULL;
	return (kQANotSupported);
}

/**************************************************************************************
 * Detach a bitmap (by copying the image data).
 *************************************************************************************/

TQAError TtBitmapDetach (
	TQABitmap			*bitmap)			/* Previously allocated by QABitmapNew() */
{
	TTtBitmap			*myBitmap;
	
	myBitmap = (TTtBitmap *) bitmap;

	/*
	 * Copy the image data. Not implemented, so for now we return an error.
	 */
	
	return (kQANotSupported);
}

/**************************************************************************************
 * Delete a bitmap.
 *************************************************************************************/

void TtBitmapDelete (
	TQABitmap			*bitmap)			/* Previously allocated by QABitmapNew() */
{
	TTtBitmap			*myBitmap;
	
	myBitmap = (TTtBitmap *) bitmap;
	
	/*
	 * Delete the bitmap. Not yet implemented.
	 */
}






