/******************************************************************************
 **																			 **
 ** 	Module:		TtTexture.c												 **
 ** 																		 **
 ** 	Purpose: 	Empty rasterizer drawing engine.						 **
 ** 				Methods for texture-mapped triangles.					 **
 ** 																		 **
 ** 	Author:		Mike W. Kelley											 **
 ** 																		 **
 **					2/3/95	Revised for 0.9 SDK release						 **
 ** 																		 **
 ** 	Copyright (C) 1994-95 Apple Computer, Inc.  All rights reserved.	 **
 ** 	Apple Computer Confidential											 **
 ** 																		 **
 *****************************************************************************/

/* System */
#include <stdlib.h>
#include <math.h>

#include "Drive3D.h"
#include "Drive3D_system.h"
#include "TtTinselTown.h"

/************************************************************************************************
 * Draw a Texture-mapped triangle.
 ***********************************************************************************************/

void TtDrawTriTexture (
	const TQADrawContext	*drawContext,		/* Draw context */
	const TQAVTexture 	*v0,				/* Vertex 0 */
	const TQAVTexture 	*v1,				/* Vertex 1 */
	const TQAVTexture 	*v2,				/* Vertex 2 */
	unsigned long		flags)				/* Flags */
{
	TTtDrawPrivate		*myPrivate;
	TTtTexture			*texture;
	
	myPrivate = (TTtDrawPrivate *) drawContext->drawPrivate;
	texture = (TTtTexture *) myPrivate->state [kQATag_Texture].i;
}
