// ===========================================================================
//	CCLuTPopupMenu.h
// ===========================================================================


#pragma once


#include "CSmartStdPopupMenu.h"


const short kMaxCLuTCount = 		40;
const ResType kCLuT_FileType = 		'RSRC';
const ResType kCLuT_ResourceType = 	'clut';


class CCLuTPopupMenu : public CSmartStdPopupMenu	{
public:
	enum { class_ID = 'Cpop' };

	static CCLuTPopupMenu* CreateCLuTPopupMenuStream(LStream *inStream);
	
	static void InitializeMenu();
	static void ReinitializeMenu();

	static void UpdatePopupMenus();
	static void BeginUpdate();
	static void EndUpdate();

	static void AppendSharedItem(const Str255 inItemString, void* inData = nil, Boolean inIgnoreMetaCharacters = true);
	static void AppendPossiblyNewItem(const Str255 inItemString, void* inData);
	static void InsertSharedItem(const Str255 inItemString, Int16 inAfterItem, void* inData = nil, Boolean inIgnoreMetaCharacters = true);
//	static void AppendSharedResourceItems(ResType inResType, void* inData = nil);
//	static void InsertSharedResourceItems(ResType inResType, Int16 inAfterItem, void* inData = nil);
	static void DeleteSharedItem(Int16 inItemNumber);
	static void AppendDivider();
	
	static Int16 GetSharedItemFromString(const Str255 inString);
	static Int16 GetSharedItemFromString(const char* inString);
	static Int16 GetSharedItemFromData(const void* inData);
	
	static Boolean GetSharedDataFromString(const Str255 inString, void* outData);
	static Boolean GetSharedDataFromString(const char* inString, void* outData);
	static Boolean GetSharedDataFromItem(Int16 inIndex, void* outData);

	CCLuTPopupMenu(const SPaneInfo &inPaneInfo,
		MessageT inValueMessage, Int16 inTitleOptions,
		ResIDT inMENUid, Int16 inTitleWidth,
		Int16 inPopupVariation, ResIDT inTextTraitsID,
		Str255 inTitle, OSType inResTypeMENU,
		Int16 inInitialMenuItem);
	CCLuTPopupMenu(const SPaneInfo &inPaneInfo,
		MessageT inValueMessage, Int32 inMaxValue,
		ResIDT inTextTraitsID, ControlHandle inMacControlH);
	CCLuTPopupMenu(LStream *inStream);
	virtual ~CCLuTPopupMenu();

	virtual void SetValue(Int32 inValue);
	virtual void SetValueByData(const void* inData);
	virtual Boolean GetData(void* outData) const;

  virtual void AppendItem(const Str255 inItemString);
  virtual void InsertItem(const Str255 inItemString, Int16 inAfterItem);
//  virtual void AppendResourceItems(ResType inResType);
//  virtual void InsertResourceItems(ResType inResType, Int16 inAfterItem);
  virtual void DeleteItem(Int16 inItemNumber);
  virtual void UpdateValues();

	virtual void BroadcastValueMessage();
	
		virtual MenuHandle
	GetMacMenuH() const
	{
		return sMenuH;
	}


// ---------------------------------------------------------------------------
protected:
	static MenuHandle sMenuH;
	static short sMenuID;
	static LList sPopupMenuList;
	static LList sDataList;
	static Boolean sDoUpdate;
	static Boolean sAddedDivider;
	Str255 mValueString;
	
	void ChooseCLuT();

	
// ---------------------------------------------------------------------------
private:
	void		InitCLuTPopupMenu();
};


//#ifdef __cplusplus
//extern "C" {
//#endif
//
//
//int S3FSSpecComparator(
//	const void*		inFSSpec1,
//	const void*		inFSSpec2);
//
//	
//#ifdef __cplusplus
//}
//#endif
