// ===========================================================================
// CEnablerView.h
// ===========================================================================


#pragma once


#include <LView.h>
#include <LCommander.h>
#include <LListener.h>


// ===========================================================================
// Constants
// ===========================================================================

enum EEnablerResult {
	eEnablerResult_Enable,
	eEnablerResult_Disable,
	eEnablerResult_IgnoreMessage
};


// ===========================================================================
// Types
// ===========================================================================

typedef EEnablerResult (*EnablerFunctionPtr)(MessageT inMessage, void* ioParam);


// ===========================================================================
// Class
// ===========================================================================

class CEnablerView
	: public LView,
	  public LCommander,
	  public LListener {
public:
	enum { class_ID = 'LVEW' };
	
		static CEnablerView*
	CreateEnablerViewStream(
		LStream*				inStream);
		
	CEnablerView(
		const CEnablerView 		&inOriginal);
	CEnablerView(
		const SPaneInfo&		inPaneInfo,
		const SViewInfo&		inViewInfo,
		EnablerFunctionPtr		inEnablerFunction);
	CEnablerView(
		LStream*				inStream);
	~CEnablerView();
	
		void
	SetEnablerFunction(
		EnablerFunctionPtr		inEnablerFunction);
	
		void
	ListenToMessage(
		MessageT				inMessage,
		void*					ioParam);
		
		Boolean
	ObeyCommand(
		CommandT				inCommand,
		void*					ioParam);

protected:
	EnablerFunctionPtr			mEnablerFunction;
	
	CEnablerView();
};

	