// ===========================================================================
//	CEnginePopupMenu.h
// ===========================================================================


#pragma once


#include "CSharedPopupMenu.h"


class	CEnginePopupMenu : public CSmartStdPopupMenu {
//class	CEnginePopupMenu : public CSharedPopupMenu {
public:
	enum { class_ID = 'Epop' };
	
	static CEnginePopupMenu* CreateEnginePopupMenuStream(LStream *inStream);
	
	static void InitializeMenu();
	static void ReinitializeMenu();

	static void UpdatePopupMenus();
	static void BeginUpdate();
	static void EndUpdate();

	static void AppendSharedItem(const Str255 inItemString /*, void* inData = nil */);
	static void InsertSharedItem(const Str255 inItemString, Int16 inAfterItem /*, void* inData = nil */);
	static void DeleteSharedItem(Int16 inItemNumber);
	
	static Int16 GetSharedItemFromString(const Str255 inString);
	static Int16 GetSharedItemFromString(const char* inString);
//	Int16 GetSharedItemFromData(const void* inData);
	
//	void* GetSharedDataFromString(const Str255 inString);
//	void* GetSharedDataFromString(const char* inString);
//	void* GetSharedDataFromItem(Int16 inIndex);

	CEnginePopupMenu(LStream *inStream);
	virtual ~CEnginePopupMenu();

	virtual void SetValue(Int32 inValue);
//	virtual void SetValueByData(const void* inData);
//	virtual void* GetData() const;

  virtual void AppendItem(const Str255 inItemString);
  virtual void InsertItem(const Str255 inItemString, Int16 inAfterItem);
  virtual void DeleteItem(Int16 inItemNumber);
  virtual void UpdateValues();

		virtual MenuHandle
	GetMacMenuH() const
	{
		return sMenuH;
	}


// ---------------------------------------------------------------------------
protected:
	static MenuHandle sMenuH;
	static short sMenuID;
	static LList sPopupMenuList;
//	static LList sDataList;
	static Boolean sDoUpdate;
	Str255 mValueString;


// ---------------------------------------------------------------------------
private:
	void		InitEnginePopupMenu();
};

