// ===========================================================================
//	CRunDoc.h
// ===========================================================================


#pragma once


#include <LDynamicArray.h>
#include <LListener.h>
#include <LStdControl.h>
#include <string.h>

#include "S3TestSystem.h"
#include "CSmartSingleDoc.h"
#include "CSmartTextEdit.h"


const ResIDT	WIND_RunDoc					= 5000;

const MessageT	msg_PopupMenu_Test			= 5000;
const MessageT	msg_Button_Run				= 5003;

const PaneIDT	pane_Caption_CurSettings	= 5001;
const PaneIDT	pane_PopupMenu_Test			= 5002;
const PaneIDT	pane_Button_Run				= 5003;

const PaneIDT	pane_Scroller_Output		= 5005;
const PaneIDT	pane_TextEdit_Output		= 5004;


class CSettingsDoc;
class CSmartStdPopupMenu;

class CRunDoc :
	public CSmartSingleDoc,
	public LListener 
{
public:
	enum { class_ID = 'S3Rw' };
	
						CRunDoc(
							LCommander			*inCommander);

	virtual void		FindCommandStatus(
							CommandT			inCommand,
							Boolean				&outEnabled,
							Boolean				&outUsesMark,
							Char16				&outMark,
							Str255				outName);
	virtual void		ListenToMessage(
							MessageT			inMessage,
							void*				ioParam);
	virtual Boolean 	HandleKeyPress(
							const EventRecord	&inKeyEvent);
	virtual void		PutOnDuty();

	void				ShowHide();

	void				Print(
							long				inLength,	
							char				*inMessage);

	void 				Print(
							char				*inMessage)
						{
							Print(strlen(inMessage), inMessage);
						}

	void				RegisterTest(
							const char			*name,
							S3tTestMethod		method);

	virtual ClassIDT	GetClassID()
						{
							return class_ID;
						}

protected:
	CSettingsDoc			*mCurSettings;
	CSmartTextEdit			*mTextView;
	LCaption				*mSettingsCaption;
	LStdButton				*mRunButton;
	LDefaultOutline			*mDefaultOutline;
	CSmartStdPopupMenu		*mTestMenu;
	LDynamicArray			*mTests;
};

