// ===========================================================================
//	CSettingsDoc.h
// ===========================================================================


#pragma once


#include "CSmartSingleDoc.h"
#include "CSettingsWindow.h"
#include "CSmartTextEdit.h"
#include "CTestInfo.h"
#include "CSneak3viewApp.h"
#include "S3TestSystem.h"
#include "CTestPopupMenu.h"
#include "CCommandButton.h"


class	CSettingsDoc : public CSmartSingleDoc {
public:
	enum { class_ID = 'Sdoc' };
	enum { fileType = 'S3VF' };
	
	static CSettingsDoc* GetFrontMost();
	static void S3Print(char *inMessage, long inLength);
	static void RegisterTest(const char *inName, S3tTestPrereqs inPrereqs, S3tTestMethod inMethod);
	static Boolean GetPrefsFSSpec(FSSpec& outFSSpec);
	
	CSettingsDoc(CSneak3viewApp* inSuper, FSSpec* inFileSpec = nil);
	CSettingsDoc(const CSettingsDoc& inSettingsDoc);
	~CSettingsDoc();
					
	virtual Boolean		IsModified();
	
	virtual void		DoAESave(FSSpec &inFileSpec, OSType inFileType);
	virtual void		DoSave();
	virtual void		DoRevert();
	virtual void		DoPrint();
	
	virtual void PutOnDuty();
	
	virtual Boolean ObeyCommand(CommandT inCommand, void	*ioParam);
	virtual void FindCommandStatus(
		CommandT	inCommand,
		Boolean		&outEnabled,
		Boolean		&outUsesMark,
		Char16		&outMark,
		Str255		outName);

	void RunTest();

		S3tTestInfoP
	GetTestInfo()
	{
		return mCTestInfo.GetTestInfo();
	}

		virtual ClassIDT
	GetClassID()
	{
		return class_ID;
	}
		
						
protected:
	CTestInfo mCTestInfo;
	CTestPopupMenu* mTestMenu;
	CSmartTextEdit* mTextView;
	
	virtual void NameNewDoc(Str255 inName);
	virtual void OpenFile(FSSpec &inFileSpec);
	void SaveTestInfo();
};