// ===========================================================================
//	CSharedPopupMenu.h
// ===========================================================================


#pragma once


#include <LList.h>

#include "CSmartStdPopupMenu.h"


class	CSharedPopupMenu : public CSmartStdPopupMenu {
public:
	enum { class_ID = 'ShPM' };
	
	static CSharedPopupMenu* CreateSharedPopupMenuStream(LStream *inStream);
	
	static void UpdatePopupMenus();
	static void BeginUpdate();
	static void EndUpdate();
	static void AppendSharedItem(const Str255 inItemString);
	static void InsertSharedItem(const Str255 inItemString, Int16 inAfterItem);
	static void AppendSharedResourceItems(ResType inResType);
	static void InsertSharedResourceItems(ResType inResType, Int16 inAfterItem);
	static void DeleteSharedItem(Int16 inItemNumber);
	
	Int16 GetSharedItemFromString(const Str255 inString) const;
	Int16 GetSharedItemFromString(const char* inString) const;
	
	CSharedPopupMenu(const SPaneInfo &inPaneInfo,
		MessageT inValueMessage, Int16 inTitleOptions,
		ResIDT inMENUid, Int16 inTitleWidth,
		Int16 inPopupVariation, ResIDT inTextTraitsID,
		Str255 inTitle, OSType inResTypeMENU,
		Int16 inInitialMenuItem);
	CSharedPopupMenu(const SPaneInfo &inPaneInfo,
		MessageT inValueMessage, Int32 inMaxValue,
		ResIDT inTextTraitsID, ControlHandle inMacControlH);
	CSharedPopupMenu(LStream *inStream);
	virtual ~CSharedPopupMenu();

	void SetValue(Int32 inValue);
	
	virtual void AppendItem(const Str255 inItemString);
	virtual void InsertItem(const Str255 inItemString, Int16 inAfterItem);
	virtual void AppendResourceItems(ResType inResType);
	virtual void InsertResourceItems(ResType inResType, Int16 inAfterItem);
	virtual void DeleteItem(Int16 inItemNumber);
	virtual void UpdateValues();
	
		virtual MenuHandle
	GetMacMenuH() const
	{
		return sMenuH;
	}


// ---------------------------------------------------------------------------
protected:
	static MenuHandle sMenuH;
	static short sMenuID;
	static LList sPopupMenuList;
	static Boolean sDoUpdate;
	
	Str255 mValueString;

	
// ---------------------------------------------------------------------------
private:
	void		InitSharedPopupMenu();
};
