// ===========================================================================
//	CSmartStdPopupMenu.h
// ===========================================================================


#pragma once


#include <LStdControl.h>


class	CSmartStdPopupMenu : public LStdPopupMenu {
public:
	enum { class_ID = 'SSPM' };
	
	static CSmartStdPopupMenu* CreateSmartStdPopupMenuStream(LStream *inStream);
	
	CSmartStdPopupMenu(const SPaneInfo &inPaneInfo,
		MessageT inValueMessage, Int16 inTitleOptions,
		ResIDT inMENUid, Int16 inTitleWidth,
		Int16 inPopupVariation, ResIDT inTextTraitsID,
		Str255 inTitle, OSType inResTypeMENU,
		Int16 inInitialMenuItem);
	CSmartStdPopupMenu(const SPaneInfo &inPaneInfo,
		MessageT inValueMessage, Int32 inMaxValue,
		ResIDT inTextTraitsID, ControlHandle inMacControlH);
	CSmartStdPopupMenu(LStream *inStream);

	virtual void AppendItem(const Str255 inItemString);
	virtual void InsertItem(const Str255 inItemString, Int16 inAfterItem);
	virtual void AppendResourceItems(ResType inResType);
	virtual void InsertResourceItems(ResType inResType, Int16 inAfterItem);
	virtual void DeleteItem(Int16 inItemNumber);
	virtual void UpdateValues();

	void BroadcastValueMessage();

	void GetString(Str255 outString) const;
	void GetString(char* outString) const;
	void SetValueByString(Str255 inString);
	void SetValueByString(char* inString);
	
		// Mapping between item values and item strings

	void GetStringFromItem(Int16 inIndex, Str255 outString) const;
	void GetStringFromItem(Int16 inIndex, char* outString) const;
	Int16 GetItemFromString(const Str255 inString) const;
	Int16 GetItemFromString(const char* inString) const;

		Boolean
	GetBroadcastString() const
	{
		return mBroadcastString;
	}
	
		void
	SetBroadcastString(Boolean inBroadcastString) 
	{
		mBroadcastString = inBroadcastString;
	}
	
		virtual MenuHandle
	GetMacMenuH() const
	{
		return mMenuH;
	}


// ---------------------------------------------------------------------------
protected:
	MenuHandle mMenuH;
	Boolean mBroadcastString;

	
// ---------------------------------------------------------------------------
private:
	void		InitSmartStdPopupMenu();
};
