// ===========================================================================
//	CSmartTextEdit.h
// ===========================================================================


#pragma once


#include <LTextEdit.h>


const Int16 TextPosition_End = 32767;


class CSmartTextEdit : public LTextEdit {
public:
	enum { class_ID = 'SMTE' };

	static CSmartTextEdit*	CreateSmartTextEditStream(LStream *inStream);

						CSmartTextEdit();
						CSmartTextEdit(const SPaneInfo &inPaneInfo,
								const SViewInfo &inViewInfo,
								Uint16 inTextAttributes,
								ResIDT inTextTraitsID);
						CSmartTextEdit(LStream *inStream);
	 
	virtual Boolean		HandleKeyPress(const EventRecord& inKeyEvent);

	void AppendText(char* inText, long inTextLength);
	void InsertText(char* inText, long inTextLength, long inPosition);
	void UserChangedText();
	
		Boolean
	IsDirty()
	{
		return mIsDirty;
	}
	
		void
	SetDirty(Boolean inDirty)
	{
		mIsDirty = inDirty;
	}


protected:
  Boolean mIsDirty;
};

