// ===========================================================================
//	CSneak3viewApp.h
// ===========================================================================

#pragma once

#ifndef CSneak3viewApp_h
#define CSneak3viewApp_h

#include "S3Messages.h"

#ifdef __cplusplus

#include <LDocApplication.h>
#include "CTinselTestWindow.h"
#include "CSmartTextEdit.h"


class CSneak3viewApp : public LDocApplication {
public:
	static CSneak3viewApp*	Instance();
	
							CSneak3viewApp();
	virtual					~CSneak3viewApp();
	
	virtual void			StartUp();
	void 					HandleAppleEvent(
								const AppleEvent	&inAppleEvent,
								AppleEvent			&outAEReply,
								AEDesc				&outResult,
								long				inAENumber);
	virtual Boolean			ObeyCommand(
								CommandT	inCommand,
								void		*ioParam = nil);
	virtual void			FindCommandStatus(
								CommandT	inCommand,
								Boolean		&outEnabled,
								Boolean		&outUsesMark,
								Char16		&outMark,
								Str255		outName);

	virtual void			OpenDocument(FSSpec *inMacFSSpec);
	virtual LModelObject*	MakeNewDocument();
	virtual void			ChooseDocument();
	
	void CreateTestWindows();
	void CloseTestWindows();
	void SelectTestWindows();
	void ShowTestWindows();
	void HideTestWindows();
	void SaveTestOutput();
	void CompareWindows();
	void ShowAboutBox();

	CTinselTestWindow*		GetLeftTinselTestWindow()
							{
								return mLeftTestWindow;
							}
	
	CTinselTestWindow*		GetRightTinselTestWindow()
							{
								return mRightTestWindow;
							}
	
protected:
	static CSneak3viewApp* 	sInstance;
	CTinselTestWindow*		mLeftTestWindow;
	CTinselTestWindow*		mRightTestWindow;
};


#endif /* __cplusplus */


#endif /* CSneak3viewApp_h */

