// ===========================================================================
//	CStringPopupMenu.h
// ===========================================================================


#pragma once


#include "CSmartStdPopupMenu.h"


class	CStringPopupMenu : public CSmartStdPopupMenu {
public:
	enum { class_ID = 'Spop' };
	
	static CStringPopupMenu* CreateStringPopupMenuStream(LStream *inStream);
	
	CStringPopupMenu(const SPaneInfo &inPaneInfo,
		MessageT inValueMessage, Int16 inTitleOptions,
		ResIDT inMENUid, Int16 inTitleWidth,
		Int16 inPopupVariation, ResIDT inTextTraitsID,
		Str255 inTitle, OSType inResTypeMENU,
		Int16 inInitialMenuItem);
	CStringPopupMenu(
		const SPaneInfo	&inPaneInfo,
		MessageT		inValueMessage,
		Int16			inTitleOptions,
		ResIDT			inMENUid,
		Int16			inTitleWidth,
		Int16			inPopupVariation,
		ResIDT			inTextTraitsID,
		Str255			inTitle,
		OSType			inResTypeMENU,
		Str255			inInitialMenuItemString);
	CStringPopupMenu(const SPaneInfo &inPaneInfo,
		MessageT inValueMessage, Int32 inMaxValue,
		ResIDT inTextTraitsID, ControlHandle inMacControlH);
	CStringPopupMenu(LStream *inStream);

		// overridden LControl methods
		
	void BroadcastValueMessage();

	void GetString(Str255 outString) const;
	void GetString(char* outString) const;
	void SetValueByString(Str255 inString);
	void SetValueByString(char* inString);
	
		// Mapping between item values and item indexes

	void StringFromItem(Int16 inIndex, Str255 outString) const;
	void StringFromItem(Int16 inIndex, char* outString) const;
	Int16 ItemFromString(Str255 inString) const;
	Int16 ItemFromString(char* inString) const;

		Boolean
	GetBroadcastString() const
	{
		return mBroadcastString;
	}
	
		void
	SetBroadcastString(Boolean inBroadcastString) 
	{
		mBroadcastString = inBroadcastString;
	}

	
// ---------------------------------------------------------------------------
protected:
	Boolean mBroadcastString;
		

// ---------------------------------------------------------------------------
private:
	void		InitStringPopupMenu();
};
