// ===========================================================================
// CTestInfo.h
// ===========================================================================


#pragma once


#include <LListener.h>
#include <LBroadcaster.h>
#include <LWindow.h>

#include "S3TestInfo_sys.h"
#include "CTinselTestWindow.h"
#include "CEnablerView.h"


const Size kS3TestInfoTextSize = 1024;
const short kOutputPadding = 18;

const short kMaxTokenLength = 256;

const TQARect kDefaultLeftRect = { 30, 229, 50, 249 };
const TQARect kDefaultRightRect = { 250, 449, 50, 249 };

	// the panes whose Pane IDs are listed in this RidL resource all 
	// become broadcasters to the file's CTestInfo object
const ResIDT	RidL_DrawContextSettings		= 1200;

	// these are the message values sent by the 
	// Settings window's broadcasters 
const MessageT msg_Width = 1102;
const MessageT msg_Height = 1107;
const MessageT msg_LeftWindow_Left = 1110;
const MessageT msg_LeftWindow_Top = 1115;
const MessageT msg_RightWindow_Left = 1120;
const MessageT msg_RightWindow_Top = 1125;
const MessageT msg_ResetWindows = 1180;

const MessageT msg_LeftEngine = 1010;
const MessageT msg_RightEngine = 1015;

const MessageT msg_Device = 1025;
const MessageT msg_ClipRegion = 1020;
const MessageT msg_Buffering = 1030;
const MessageT msg_ZBuffering = 1035;

const MessageT msg_ZFunction = 1045;
const MessageT msg_PerspectiveZ = 1040;
const MessageT msg_Blending = 1075;
const MessageT msg_Antialiasing = 1070;

const MessageT msg_Background_Alpha = 1062;
const MessageT msg_Background_Red = 1064;
const MessageT msg_Background_Green = 1066;
const MessageT msg_Background_Blue = 1068;
const MessageT msg_LineWidth = 1052;

const MessageT msg_Texture = 1080;
const MessageT msg_TextureFormat = 1082;
const MessageT msg_TextureFilter = 1084;
const MessageT msg_TextureOp_Modulate = 1092;
const MessageT msg_TextureOp_Highlight = 1094;
const MessageT msg_TextureOp_Decal = 1096;
const MessageT msg_TextureOp_Shrink = 1098;
const MessageT msg_CreateMipmap = 1135;
const MessageT msg_LockTexture = 1185;
const MessageT msg_DetachTexture = 1140;
const MessageT msg_TextureMakeBlackTransparent = 1145;
const MessageT msg_TextureColorTable = 1250;
const MessageT msg_TextureUseTransparentIndex = 1255;
const MessageT msg_TextureTableFormat = 1260;
const MessageT msg_TextureEnablerView = 1280;

const MessageT msg_Bitmap = 1150;
const MessageT msg_BitmapFormat = 1155;
const MessageT msg_LockBitmap = 1190;
const MessageT msg_DetachBitmap = 1165;
const MessageT msg_BitmapMakeBlackTransparent = 1170;
const MessageT msg_BitmapColorTable = 1265;
const MessageT msg_BitmapUseTransparentIndex = 1275;
const MessageT msg_BitmapTableFormat = 1270;
const MessageT msg_BitmapEnablerView = 1285;

const MessageT msg_ResetRandomSeed = 1175;
const MessageT msg_Test = 1200;
const MessageT msg_RunTestButton = 1210;
const MessageT msg_ArgString = 1220;


const PaneIDT paneID_Width = 1102;
const PaneIDT paneID_Height = 1107;
const PaneIDT paneID_LeftWindow_Left = 1110;
const PaneIDT paneID_LeftWindow_Top = 1115;
const PaneIDT paneID_RightWindow_Left = 1120;
const PaneIDT paneID_RightWindow_Top = 1125;
const PaneIDT paneID_ResetWindows = 1180;

const PaneIDT paneID_LeftEngine = 1010;
const PaneIDT paneID_RightEngine = 1015;

const PaneIDT paneID_Device = 1025;
const PaneIDT paneID_ClipRegion = 1020;
const PaneIDT paneID_Buffering = 1030;
const PaneIDT paneID_ZBuffering = 1035;

const PaneIDT paneID_ZFunction = 1045;
const PaneIDT paneID_PerspectiveZ = 1040;
const PaneIDT paneID_Blending = 1075;
const PaneIDT paneID_Antialiasing = 1070;

const PaneIDT paneID_Background_Alpha = 1062;
const PaneIDT paneID_Background_Red = 1064;
const PaneIDT paneID_Background_Green = 1066;
const PaneIDT paneID_Background_Blue = 1068;
const PaneIDT paneID_LineWidth = 1052;

const PaneIDT paneID_Texture = 1080;
const PaneIDT paneID_TextureFormat = 1082;
const PaneIDT paneID_TextureFilter = 1084;
const PaneIDT paneID_TextureOp_Modulate = 1092;
const PaneIDT paneID_TextureOp_Highlight = 1094;
const PaneIDT paneID_TextureOp_Decal = 1096;
const PaneIDT paneID_TextureOp_Shrink = 1098;
const PaneIDT paneID_CreateMipmap = 1135;
const PaneIDT paneID_LockTexture = 1185;
const PaneIDT paneID_DetachTexture = 1140;
const PaneIDT paneID_TextureMakeBlackTransparent = 1145;
const PaneIDT paneID_TextureColorTable = 1250;
const PaneIDT paneID_TextureUseTransparentIndex = 1255;
const PaneIDT paneID_TextureTableFormat = 1260;
const PaneIDT paneID_TextureEnablerView = 1280;

const PaneIDT paneID_Bitmap = 1150;
const PaneIDT paneID_BitmapFormat = 1155;
const PaneIDT paneID_LockBitmap = 1190;
const PaneIDT paneID_DetachBitmap = 1165;
const PaneIDT paneID_BitmapMakeBlackTransparent = 1170;
const PaneIDT paneID_BitmapColorTable = 1265;
const PaneIDT paneID_BitmapUseTransparentIndex = 1275;
const PaneIDT paneID_BitmapTableFormat = 1270;
const PaneIDT paneID_BitmapEnablerView = 1285;

const PaneIDT paneID_ResetRandomSeed = 1175;
const PaneIDT paneID_Test = 1200;
const PaneIDT paneID_RunTestButton = 1210;
const PaneIDT paneID_ArgString = 1220;


enum EBufferingMenu {
	eBufferingMenu_Single = 1,
	eBufferingMenu_Double
};

enum EZBufferingMenu {
	eZBufferingMenu_None = 1,
	eZBufferingMenu_Shallow,
	eZBufferingMenu_Deep
};

enum EZFunctionMenu {
	eZFunctionMenu_None = 1,
	eZFunctionMenu_LT,
	eZFunctionMenu_True,
		// separator = 4
	eZFunctionMenu_EQ = 5,
	eZFunctionMenu_LE,
	eZFunctionMenu_GT,
	eZFunctionMenu_NE,
	eZFunctionMenu_GE
};

enum EPerspectiveZMenu {
	ePerspectiveZMenu_On = 1,
	ePerspectiveZMenu_Off
};

enum EBlendingMenu {
	eBlendingMenu_Premultiply = 1,
	eBlendingMenu_Interpolate,
	eBlendingMenu_OpenGL
};

enum EAntialiasingMenu {
	eAntialiasingMenu_Off = 1,
	eAntialiasingMenu_Fast,
	eAntialiasingMenu_Mid,
	eAntialiasingMenu_Best
};

enum ETextureFilterMenu {
	eTextureFilterMenu_Fast = 1,
	eTextureFilterMenu_Mid,
	eTextureFilterMenu_Best
};


class CSettingsDoc;


class CTestInfo 
	: public LListener,
		public LBroadcaster  {
public:
	static void DisposeTestInfo(S3tTestInfo* inTestInfo);
	static LGWorld* NewDeviceGWorld(Rect& inRect, Uint16 inDepth);
	static RgnHandle MakeClipRegion(const TQARect* inRect, S3eClipRegion inClipRegion);
		
	CTestInfo();
	CTestInfo(const CTestInfo& inCTestInfo);
	CTestInfo(const Handle inTestInfoH, Int16 inSettingsVersion);
	~CTestInfo();
	
	Boolean ReadFromHandle(const Handle inTestInfoH, Int16 inSettingsVersion);
	Boolean WriteToHandle(Handle outTestInfoH, Int16* outSettingsVersion);
	Boolean PrepareForTest();
	S3tTestInfoP GetTestInfo();
	void CleanUpAfterTest();
	
	void ListenToMessage(MessageT inMessage, void* ioParam);

	void LinkSettingsDoc(CSettingsDoc* inDoc, LWindow* inWindow);
	void LinkTestWindows(CTinselTestWindow* inLeftWindow, 
											 CTinselTestWindow* inRightWindow);

	void UpdateSettingsWindow();
	void UpdateTestWindows();

		Boolean
	IsDirty() const
	{
		return mIsDirty;
	}
	
	
protected:
	S3tTestInfo mTestInfo;
	S3tTestInfo* mPreparedTestInfo;
	LWindow* mSettingsWindow;
	CSettingsDoc* mSettingsDoc;
	Boolean mIsDirty;
	
	Boolean VerifySettingsVersion(const Handle inTestInfoH, Int16 inSettingsVersion);
	void UpdateLeftTestWindow();
	void UpdateRightTestWindow();

	void AddEditFieldBroadcaster(PaneIDT inPaneID);
	void SetFieldToAcceptFloats(PaneIDT inPaneID);
	void SetFieldToAcceptSignedInts(PaneIDT inPaneID);
	void LinkEnablerViewToControl(
		PaneIDT 									inEnablerViewID, 
		PaneIDT 									inControlID, 
		EnablerFunctionPtr 				inEnablerFunction);
	
	void SetPvalPopupValue(PaneIDT inPaneID, Int32 inPval);
	void SetControlValue(PaneIDT inPaneID, Int32 inValue);
	void SetEditFieldValue(PaneIDT inPaneID, long inLongValue);
	void SetEditFieldValue(PaneIDT inPaneID, float inFloatValue);
	void SetPICTPopupValue(PaneIDT inPaneID, FSSpec* inFSSpec);
	void SetStringPopupValue(PaneIDT inPaneID, char* inString);
	void SetStringPopupValue(PaneIDT inPaneID, Str255 inString);
	void SetTableFormatPopupValue(PaneIDT inPaneID, TQAColorTableType inTableType);
		void
	SetEnablerViewState(
		PaneIDT 									inPaneID, 
		MessageT 									inMessage, 
		void*											inParam);

	void SetWindows(MessageT inMessage, void* inParam);
	void SetWindowDrag(MessageT inMessage, void* ioParam);
	void SetWindowSize(void* ioParam);
	void SetEngine(MessageT inMessage, void* inParam);
	void SetBuffering(void* inParam);
	EBufferingMenu GetBuffering();
	void SetZBuffering(void* inParam);
	EZBufferingMenu GetZBuffering();
	void SetBackground(MessageT inMessage, void* inParam);
	void SetTextureOp(MessageT inMessage, void* inParam);

	Boolean LoadBitmap(S3tTestInfo* inTestInfo);
	Boolean LoadTextureMap(S3tTestInfo* inTestInfo);
	
	Boolean SetupGDevice(S3tTestInfo* inTestInfo);
	Boolean SetupMemoryDevice(S3tTestInfo* inTestInfo);
	
	static EEnablerResult TextureEnablerFunction(MessageT inMessage, void* ioParam);
	static EEnablerResult BitmapEnablerFunction(MessageT inMessage, void* ioParam);
	

private:
	void Initialize();
	void InitializeTestInfo(S3tTestInfo* inTestInfo);
};
