// ===========================================================================
//	CTestPopupMenu.h
// ===========================================================================


#pragma once


#include "CSmartStdPopupMenu.h"
#include "S3TestSystem.h"


typedef struct S3tTestTool {
	const char			*testName;
	S3tTestPrereqs 	testPrereqs;
	S3tTestMethod		testMethod;
} S3tTestTool;


class	CTestPopupMenu : public CSmartStdPopupMenu {
//class	CTestPopupMenu : public CSharedPopupMenu {
public:
	enum { class_ID = 'TSTp' };
	
	static CTestPopupMenu* CreateTestPopupMenuStream(LStream *inStream);
	
	static void InitializeMenu();
	static void ReinitializeMenu();

	static void UpdatePopupMenus();
	static void BeginUpdate();
	static void EndUpdate();

	static void AppendSharedItem(const Str255 inItemString, void* inData = nil, Boolean inIgnoreMetaCharacters = true);
	static void InsertSharedItem(const Str255 inItemString, Int16 inAfterItem, void* inData = nil, Boolean inIgnoreMetaCharacters = true);
	static void DeleteSharedItem(Int16 inItemNumber);
	
	static Int16 GetSharedItemFromString(const Str255 inString);
	static Int16 GetSharedItemFromString(const char* inString);
	static Int16 GetSharedItemFromData(const void* inData);
	
	static void GetSharedStringFromItem(Int16 inIndex, Str255 outString);
	static void GetSharedStringFromItem(Int16 inIndex, char* outString);
	
	static Boolean GetSharedDataFromString(const Str255 inString, void* outData);
	static Boolean GetSharedDataFromString(const char* inString, void* outData);
	static Boolean GetSharedDataFromItem(Int16 inIndex, void* outData);

	CTestPopupMenu(LStream *inStream);
	virtual ~CTestPopupMenu();

	virtual void SetValue(Int32 inValue);
	virtual void SetValueByData(const void* inData);
	virtual Boolean GetData(void* outData) const;

  virtual void AppendItem(const Str255 inItemString);
  virtual void InsertItem(const Str255 inItemString, Int16 inAfterItem);
  virtual void DeleteItem(Int16 inItemNumber);
  virtual void UpdateValues();

	virtual void BroadcastValueMessage();
	
		virtual MenuHandle
	GetMacMenuH() const
	{
		return sMenuH;
	}


// ---------------------------------------------------------------------------
protected:
	static MenuHandle sMenuH;
	static short sMenuID;
	static LList sPopupMenuList;
	static LList sDataList;
	static Boolean sDoUpdate;
	Str255 mValueString;


// ---------------------------------------------------------------------------
private:
	void		InitTestPopupMenu();
};

