// ===========================================================================
//	CTexturePopupMenu.h
// ===========================================================================


#pragma once


#include "CSmartStdPopupMenu.h"


const short kMaxTextureCount = 30;


class CTexturePopupMenu : public CSmartStdPopupMenu	{
public:
	enum { class_ID = 'Tpop' };

	static CTexturePopupMenu* CreateTexturePopupMenuStream(LStream *inStream);
	
	static void InitializeMenu();
	static void ReinitializeMenu();

	static void UpdatePopupMenus();
	static void BeginUpdate();
	static void EndUpdate();

	static void AppendSharedItem(const Str255 inItemString, void* inData = nil);
	static void InsertSharedItem(const Str255 inItemString, Int16 inAfterItem, void* inData = nil);
//	static void AppendSharedResourceItems(ResType inResType, void* inData = nil);
//	static void InsertSharedResourceItems(ResType inResType, Int16 inAfterItem, void* inData = nil);
	static void DeleteSharedItem(Int16 inItemNumber);
	
	Int16 GetSharedItemFromString(const Str255 inString) const;
	Int16 GetSharedItemFromString(const char* inString) const;
	Int16 GetSharedItemFromData(const void* inData) const;
	
	void* GetSharedDataFromString(const Str255 inString);
	void* GetSharedDataFromString(const char* inString);
	void* GetSharedDataFromItem(Int16 inIndex) const;

	CTexturePopupMenu(const SPaneInfo &inPaneInfo,
		MessageT inValueMessage, Int16 inTitleOptions,
		ResIDT inMENUid, Int16 inTitleWidth,
		Int16 inPopupVariation, ResIDT inTextTraitsID,
		Str255 inTitle, OSType inResTypeMENU,
		Int16 inInitialMenuItem);
	CTexturePopupMenu(const SPaneInfo &inPaneInfo,
		MessageT inValueMessage, Int32 inMaxValue,
		ResIDT inTextTraitsID, ControlHandle inMacControlH);
	CTexturePopupMenu(LStream *inStream);
	virtual ~CTexturePopupMenu();

	virtual void SetValue(Int32 inValue);
	virtual void SetValueByData(const void* inData);
	virtual void* GetData() const;

  virtual void AppendItem(const Str255 inItemString);
  virtual void InsertItem(const Str255 inItemString, Int16 inAfterItem);
//  virtual void AppendResourceItems(ResType inResType);
//  virtual void InsertResourceItems(ResType inResType, Int16 inAfterItem);
  virtual void DeleteItem(Int16 inItemNumber);
  virtual void UpdateValues();

	virtual void BroadcastValueMessage();
	
		virtual MenuHandle
	GetMacMenuH() const
	{
		return sMenuH;
	}


// ---------------------------------------------------------------------------
protected:
	static MenuHandle sMenuH;
	static short sMenuID;
	static LList sPopupMenuList;
	static LList sDataList;
	static Boolean sDoUpdate;
	Str255 mValueString;
	

	
// ---------------------------------------------------------------------------
private:
	void		InitTexturePopupMenu();
};
