// ===========================================================================
// LTab.h
// ===========================================================================


#pragma once


#include <LTextButton.h>


class LTab : public LTextButton {
public:
	enum { class_ID = 'TABB' };
	
	static LTab* 			CreateTabStream(
											LStream* 		inStream);

										LTab(
											LStream* 		inStream);
										~LTab();

	virtual void			FinishCreateSelf();
	virtual void			DrawSelf();
	virtual void 			HotSpotAction(
											Int16	inHotSpot,
											Boolean	inCurrInside,
											Boolean	inPrevInside);
	virtual void			HotSpotResult(
											Int16				inHotSpot);
	virtual void			SetValue(
											Int32 			inValue);
	
	PaneIDT 					GetTabViewID() const;
	void							SetTabIndex(
											Int32 			inIndex);
	Int32							GetTabIndex() const;
	
	void							SetLayeredRegion(
											RgnHandle 	inNewRegionH);
	RgnHandle					GetLayeredRegion();
	RgnHandle					GetFullRegion();
	
	void							SetDrawLayer(
											Int16 			inDrawLayer);
	Int16							GetDrawLayer();
	
protected:
	RgnHandle					mTabRegionFull;
	RgnHandle					mTabRegionLayered;
	PolyHandle				mTabPoly;
	Int32							mTabIndex;
	Int16							mDrawLayer;
	PaneIDT						mTabViewID;
	RGBColor					mSelectedFillColor;
	RGBColor					mUnselectedFillColor;
	
	Int16							mLabelOffsetLeft;
	Int16							mLabelOffsetTop;
	Int16							mLabelOffsetRight;
	Int16							mLabelOffsetBottom;

	virtual void			AdjustSize();
	virtual void			CreateRegion();
	virtual void 			DrawTab(
											Boolean 		inInverse);
	virtual void 			DrawLabel(
											Boolean 		inInverse);
	
private:
										LTab();
};
