// ===========================================================================
// LTabViewAlternator.h
// ===========================================================================


#pragma once


#include <LList.h>
#include <LListener.h>

#include "LViewAlternator.h"
#include "LTab.h"


class LTabViewAlternator :
	public LViewAlternator,
	public LListener {
public:
	enum { class_ID = 'TVAL' };
	
	static LTabViewAlternator* 		CreateTabViewAlternatorStream(
																	LStream*			inStream);

																LTabViewAlternator(
																	LStream* 			inStream);
																~LTabViewAlternator();

	virtual void 									FinishCreateSelf();
	
	void 													ListenToMessage(
																	MessageT			inMessage,
																	void*					ioParam);
	
	void 													DrawSelf();

	virtual void 									ShowView(
																	Int32 				inViewIndex);
	virtual void 									ShowNextView();
	virtual void 									ShowPreviousView();
	
	virtual void 									AddTab(
																	LTab* inTab);
	
protected:
	LList 												mTabList;
	Int16													mCurrentTabLeft;
	
	Int16 												mViewLeft;
	Int16 												mViewTop;
	Int16 												mViewWidth;
	Int16 												mViewHeight;

	Int16 												mTabsLeft;
	Int16 												mTabsTop;
	Int16 												mTabsWidth;
	Int16 												mTabsHeight;

	Int16 												mTabOverlap;

	void 													DrawTabs();
	void													DrawCurrentView();
	void													BringTabToFront();
	
private:
	LTabViewAlternator();
};
