/*
 	File:		NanoKernelPriv.h
 
 	Contains:	Headers and interfaces for the V0 NanoKernel
 
 	Version:	Maxwell
 
 	DRI:		Thomas Mason
 
 	Copyright:	 1984-1995 by Apple Computer, Inc.
 				All rights reserved.
 
 	Warning:	*** APPLE INTERNAL USE ONLY ***
 				This file contains unreleased SPI's
 
 	BuildInfo:	Built by:			Build God
 				With Interfacer:	1.1d12  
 				From:				NanoKernelPriv.i
 					Revision:		6
 					Dated:			10/13/94
 					Last change by:	TW
 					Last comment:	Prevent "Emulator68KContectBlock" struct from outputing in Asm
 
 	Bugs:		Report bugs to Radar component System Interfaces, Latest
 				List the version information (from above) in the Problem Description.
 
*/

#ifndef __NANOKERNELPRIV__
#define __NANOKERNELPRIV__


#ifndef __TYPES__
#include <Types.h>
#endif
/*	#include <ConditionalMacros.h>								*/

#ifdef __cplusplus
extern "C" {
#endif

#if STRUCTALIGNMENTSUPPORTED
#pragma options align=mac68k
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

struct RISCContextBlock {
	unsigned long					SusCtxFlags;
	unsigned long					SusEnables;
	unsigned long					unused1[6];
	unsigned long					unused2;
	unsigned long					SusMemInfo;
	unsigned long					pad1;
	unsigned long					SusMemData;
	unsigned long					pad2;
	unsigned long					SusMemAddress;
	unsigned long					pad3;
	unsigned long					SusMemUpdateEA;
	unsigned long					XcpCtxFlags;
	unsigned long					XcpEnables;
	unsigned long					pad4;
	unsigned long					XcpHandlerAddr;
	unsigned long					pad5;
	unsigned long					XcpHandlerParam;
	unsigned long					pad6;
	unsigned long					XcpRestoreAddr;
	unsigned long					XcpPMR;
	unsigned long					XcpMemInfo;
	unsigned long					pad7;
	unsigned long					XcpMemData;
	unsigned long					pad8;
	unsigned long					XcpMemAddress;
	unsigned long					pad9;
	unsigned long					XcpMemUpdateEA;
	unsigned long					pad10;
	unsigned long					XcpNIA;
	unsigned long					pad11;
	unsigned long					XcpLR;
	unsigned long					pad12;
	unsigned long					XcpGPR03;
	unsigned long					pad13;
	unsigned long					XcpGPR04;
	unsigned long					pad14;
	unsigned long					unused3;
	unsigned long					pad15;
	unsigned long					unused4;
	unsigned long					pad16;
	unsigned long					unused5;
	unsigned long					pad17;
	unsigned long					unused6;
	unsigned long					unused7;
	unsigned long					RegMQ;
	unsigned long					unused8;
	unsigned long					unused9;
	unsigned long					unused10;
	unsigned long					RegXER;
	unsigned long					unused11;
	unsigned long					RegCR;
	unsigned long					unused12;
	unsigned long					RegFPSCR;
	unsigned long					pad18;
	unsigned long					RegLR;
	unsigned long					pad19;
	unsigned long					RegCTR;
	unsigned long					pad20;
	unsigned long					RegNIA;
	unsigned long					pad21;
	unsigned long					GPR_0;
	unsigned long					pad22;
	unsigned long					GPR_1;
	unsigned long					pad23;
	unsigned long					GPR_2;
	unsigned long					pad24;
	unsigned long					GPR_3;
	unsigned long					pad25;
	unsigned long					GPR_4;
	unsigned long					pad26;
	unsigned long					GPR_5;
	unsigned long					pad27;
	unsigned long					GPR_6;
	unsigned long					pad28;
	unsigned long					GPR_7;
	unsigned long					pad29;
	unsigned long					GPR_8;
	unsigned long					pad30;
	unsigned long					GPR_9;
	unsigned long					pad31;
	unsigned long					GPR_10;
	unsigned long					pad32;
	unsigned long					GPR_11;
	unsigned long					pad33;
	unsigned long					GPR_12;
	unsigned long					pad34;
	unsigned long					GPR_13;
	unsigned long					pad35;
	unsigned long					GPR_14;
	unsigned long					pad36;
	unsigned long					GPR_15;
	unsigned long					pad37;
	unsigned long					GPR_16;
	unsigned long					pad38;
	unsigned long					GPR_17;
	unsigned long					pad39;
	unsigned long					GPR_18;
	unsigned long					pad40;
	unsigned long					GPR_19;
	unsigned long					pad41;
	unsigned long					GPR_20;
	unsigned long					pad42;
	unsigned long					GPR_21;
	unsigned long					pad43;
	unsigned long					GPR_22;
	unsigned long					pad44;
	unsigned long					GPR_23;
	unsigned long					pad45;
	unsigned long					GPR_24;
	unsigned long					pad46;
	unsigned long					GPR_25;
	unsigned long					pad47;
	unsigned long					GPR_26;
	unsigned long					pad48;
	unsigned long					GPR_27;
	unsigned long					pad49;
	unsigned long					GPR_28;
	unsigned long					pad50;
	unsigned long					GPR_29;
	unsigned long					pad51;
	unsigned long					GPR_30;
	unsigned long					pad52;
	unsigned long					GPR_31;
	unsigned long					pad53;
	unsigned long					FPR_0;
	unsigned long					pad54;
	unsigned long					FPR_1;
	unsigned long					pad55;
	unsigned long					FPR_2;
	unsigned long					pad56;
	unsigned long					FPR_3;
	unsigned long					pad57;
	unsigned long					FPR_4;
	unsigned long					pad58;
	unsigned long					FPR_5;
	unsigned long					pad59;
	unsigned long					FPR_6;
	unsigned long					pad60;
	unsigned long					FPR_7;
	unsigned long					pad61;
	unsigned long					FPR_8;
	unsigned long					pad62;
	unsigned long					FPR_9;
	unsigned long					pad63;
	unsigned long					FPR_10;
	unsigned long					pad64;
	unsigned long					FPR_11;
	unsigned long					pad65;
	unsigned long					FPR_12;
	unsigned long					pad66;
	unsigned long					FPR_13;
	unsigned long					pad67;
	unsigned long					FPR_14;
	unsigned long					pad68;
	unsigned long					FPR_15;
	unsigned long					pad69;
	unsigned long					FPR_16;
	unsigned long					pad70;
	unsigned long					FPR_17;
	unsigned long					pad71;
	unsigned long					FPR_18;
	unsigned long					pad72;
	unsigned long					FPR_19;
	unsigned long					pad73;
	unsigned long					FPR_20;
	unsigned long					pad74;
	unsigned long					FPR_21;
	unsigned long					pad75;
	unsigned long					FPR_22;
	unsigned long					pad76;
	unsigned long					FPR_23;
	unsigned long					pad77;
	unsigned long					FPR_24;
	unsigned long					pad78;
	unsigned long					FPR_25;
	unsigned long					pad79;
	unsigned long					FPR_26;
	unsigned long					pad80;
	unsigned long					FPR_27;
	unsigned long					pad81;
	unsigned long					FPR_28;
	unsigned long					pad82;
	unsigned long					FPR_29;
	unsigned long					pad83;
	unsigned long					FPR_30;
	unsigned long					pad84;
	unsigned long					FPR_31;
};
typedef struct RISCContextBlock RISCContextBlock, *RISCContextBlockPtr;

struct Emulator68KContextBlock {
	unsigned long					D0;
	unsigned long					D1;
	unsigned long					D2;
	unsigned long					D3;
	unsigned long					D4;
	unsigned long					D5;
	unsigned long					D6;
	unsigned long					D7;
	unsigned long					A0;
	unsigned long					A1;
	unsigned long					A2;
	unsigned long					A3;
	unsigned long					A4;
	unsigned long					A5;
	unsigned long					A6;
	unsigned long					PC;
	unsigned long					SR;
};
typedef struct Emulator68KContextBlock Emulator68KContextBlock, *Emulator68KContextBlockPtr;

#define CCRCBitPhase 0
#define CCRVBitPhase 1
#define CCRZBitPhase 2
#define CCRNBitPhase 3
#define CCRXBitPhase 4

enum {
	ecNoException				= 0,
	ecSystemCall,
	ecTrapInstr,
	ecFloatException,
	ecInvalidInstr,
	ecPrivilegedInstr,
	ecUnused1,
	ecMachineCheck,
	ecInstTrace,
	ecUnused2,
	ecInstInvalidAddress,
	ecInstHardwareFault,
	ecInstPageFault,
	ecInstUnused3,
	ecInstSupAccessViolation,
	ecUnused4,
	ecDataTrace,
	ecUnused5,
	ecDataInvalidAddress,
	ecDataHardwareFault,
	ecDataPageFault,
	ecDataWriteViolation,
	ecDataSupAccessViolation,
	ecDataSupWriteViolation
};

enum {
	b_CtxFlagSystemContext		= 8,
	b_CtxFlagHWPowerCompatible	= 13,
	b_CtxFlagHWOptionalInstr	= 14,
	b_CtxFlagHW64Bit			= 15,
	b_CtxFlagFpExceptionMode0	= 20,
	b_CtxFlagStepTraceEnabled,
	b_CtxFlagBranchTraceEnabled,
	b_CtxFlagFpExceptionMode1,
	b_CtxFlagUnused24,
	b_CtxFlagUnused25,
	b_CtxFlagTracePending,
	b_CtxFlagMemInfoValid,
	b_CtxFlag64BitMode,
	b_CtxFlagEmulatePowerCompatible,
	b_CtxFlagEmulateOptionalInstr,
	b_CtxFlagInstuctionContinuation
};

enum {
	ExceptionHandled			= 0,
	PropagateException			= 1
};


#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#if STRUCTALIGNMENTSUPPORTED
#pragma options align=reset
#endif

#ifdef __cplusplus
}
#endif

#endif /* __NANOKERNELPRIV__ */
