// ===========================================================================
// 	S3TestInfo_sys.h
// ===========================================================================


#pragma once


// ===========================================================================
//	Includes
// ===========================================================================

#include <Files.h>

#include "S3TestInfo.h"
#include "S3Image.h"
#include "S3PICTList.h"


#ifdef __cplusplus
extern "C" {
#endif


// ===========================================================================
//	Types
// ===========================================================================

typedef struct S3tTestInfo {	
	unsigned long		leftMicroseconds;
	unsigned long		rightMicroseconds;
	Str255				testName;
	char				argString[kMaxArgStringLength];
	S3PICTList			pictList;
	TQADrawContext*		leftContext;
	TQADrawContext*		rightContext;
	TQAEngine*			leftEngine;
	char				leftEngineName[kMaxEngineNameLength];
	TQAEngine*			rightEngine;
	char				rightEngineName[kMaxEngineNameLength];
	TQARect				leftRect;
	TQARect				rightRect;
	Rect				leftGlobalRect;
	Rect				rightGlobalRect;
	TQADevice			leftDevice;
	TQADevice			rightDevice;
	S3eDevice			deviceMenu;
	struct LGWorld*		leftDeviceGWorld;
	struct LGWorld*		rightDeviceGWorld;
	TQAClip				leftClip;
	TQAClip				rightClip;
	S3eClipRegion		clipRegionMenu;
	unsigned long		contextFlags;
	long				zFunction;
	long				perspectiveZ;
	long				blending;
	long				antialiasing;
	float				alpha;
	float				red;
	float				green;
	float				blue;
	float				lineWidth;
	FSSpec				textureFSSpec;
	struct CTQAImage*	textureImage;
	long				textureWidth;
	long				textureHeight;
	long				textureRowBytes;
	TQATexture*			leftTexture;
	TQATexture*			rightTexture;
	TQAImagePixelType	textureFormat;
	unsigned long		textureFilter;
	unsigned long		textureOp;
	unsigned long		textureFlags;
	Boolean				detachTexture;
	Boolean				textureMakeBlackTransparent;
	FSSpec				bitmapFSSpec;
	struct CTQAImage*	bitmapImage;
	long				bitmapWidth;
	long				bitmapHeight;
	long				bitmapRowBytes;
	TQABitmap*			leftBitmap;
	TQABitmap*			rightBitmap;
	TQAImagePixelType	bitmapFormat;
	unsigned long		bitmapFlags;
	Boolean				detachBitmap;
	Boolean				bitmapMakeBlackTransparent;
	Boolean				resetRandomSeed;
	TQAColorTable* 		leftTextureColorTable;
	TQAColorTable* 		rightTextureColorTable;
	TQAColorTableType	textureColorTableType;
	Boolean				textureUseTransparentIndex;
	TQAColorTable* 		leftBitmapColorTable;
	TQAColorTable* 		rightBitmapColorTable;
	TQAColorTableType	bitmapColorTableType;
	Boolean				bitmapUseTransparentIndex;
} S3tTestInfo;


typedef struct S3tTestInfo	S3tTestInfo;
typedef S3tTestInfo*		S3tTestInfoP;


#ifdef __cplusplus
}
#endif
