// ===========================================================================
// CBroadcastEditField.h
// ===========================================================================


#pragma once


#include <LEditField.h>
#include <LBroadcaster.h>


class CBroadcastEditField 
	: public LEditField,
	  public LBroadcaster {
public:
	enum { class_ID = 'Bedt' };

	static CBroadcastEditField*	CreateBroadcastEditFieldStream(LStream *inStream);
	static EKeyStatus UnsignedFloatField(const EventRecord &inKeyEvent);
	static EKeyStatus SignedIntField(const EventRecord &inKeyEvent);
	
	CBroadcastEditField();
	CBroadcastEditField(const LEditField	&inOriginal);
	CBroadcastEditField(
		const SPaneInfo	&inPaneInfo,
		Str255			inString,
		ResIDT			inTextTraitsID,
		Int16			inMaxChars,
		Boolean			inHasBox,
		Boolean			inHasWordWrap,
		KeyFilterFunc	inKeyFilter,
		LCommander		*inSuper);
	CBroadcastEditField(
		const SPaneInfo	&inPaneInfo,
		Str255			inString,
		ResIDT			inTextTraitsID,
		Int16			inMaxChars,
		Uint8			inAttributes,
		KeyFilterFunc	inKeyFilter,
		LCommander		*inSuper);
	CBroadcastEditField(LStream *inStream);

//	virtual void SetDescriptor(const char* inDescriptor);
//	virtual char* GetDescriptor(char* outDescriptor) const;
	
	virtual void UserChangedText();
	void SetValueAsFloat(float inFloatValue);
	float GetValueAsFloat();
};
	  

