// ===========================================================================
//	CPvalPopupMenu.h
// ===========================================================================


#pragma once


#include <Menus.h>
#include <LStdControl.h>


class	CPvalPopupMenu : public LStdPopupMenu {
public:
	enum { class_ID = 'Vpop' };
	
	static CPvalPopupMenu* CreatePvalPopupMenuStream(LStream *inStream);
	
	CPvalPopupMenu(const SPaneInfo &inPaneInfo,
		MessageT inValueMessage, Int16 inTitleOptions,
		ResIDT inMENUid, Int16 inTitleWidth,
		Int16 inPopupVariation, ResIDT inTextTraitsID,
		Str255 inTitle, OSType inResTypeMENU,
		Int16 inInitialMenuItem);
	CPvalPopupMenu(const SPaneInfo &inPaneInfo,
		MessageT inValueMessage, Int32 inMaxValue,
		ResIDT inTextTraitsID, ControlHandle inMacControlH);
	CPvalPopupMenu(LStream *inStream);
	virtual		~CPvalPopupMenu();

		// overridden LControl methods
		
	void BroadcastValueMessage();

	Int32 GetPval() const;
	void SetValueByPval(Int32 inPval);
	
		// Mapping between item values and item indexes

	Int32 PvalFromItem(Int16 inIndex) const;
	Int16 ItemFromPval(Int32 inValue) const;
	Int32	SyntheticPvalFromItem(Int16 inIndex) const;
	
	Boolean		FindNextValue(Int16 &ioIndex, Int32 &outValue) const;
	
		// Manipulating Items
	
	void		SetItemValue(Int16 inIndex, Int32 inValue);
	void		InsertValue(Str255 inItemText, Int32 inValue,
								Int16 inAfterItem);
	void		RemoveValue(Int32 inValue);
	void		RemoveItem(Int16 inItemToRemove);
	Boolean		ItemIsEnabled(Int16 inIndex) const;
	
		ResIDT
	GetMenuID() const
	{
		return mMENUid;
	}
	
		Boolean
	GetBroadcastPval() const
	{
		return mBroadcastPval;
	}
	
		void
	SetBroadcastPval(Boolean inBroadcastPval) 
	{
		mBroadcastPval = inBroadcastPval;
	}

	
// ---------------------------------------------------------------------------
protected:
	MenuHandle	mMacMenuH;
	ResIDT		mMENUid;
	LMenu* mNextMenu;
	Int16		mNumPvals;
	Int32** mPvals;
	Boolean mBroadcastPval;
		
	void		ReadPvals();


// ---------------------------------------------------------------------------
private:
	void		InitPvalPopupMenu();
};
