// ===========================================================================
//	CTinselTestWindow.h
// ===========================================================================


#pragma once


#include <LWindow.h>
#include <LListener.h>
#include <LBroadcaster.h>
#include <UGWorld.h>


const	ResIDT								WIND_TinselTest_Left = 					2000;
const	ResIDT								WIND_TinselTest_Right = 				2500;

const	PaneIDT								paneID_TinselTestWindow_Left = 	2000;
const	PaneIDT								paneID_TinselTestWindow_Right = 2500;

const Int8 									TestWindow_Left = 							1;
const Int8 									TestWindow_Right = 							2;

const	MessageT 							msg_TestWindow_Move = 					2500;
const MessageT 							msg_TestWindow_Drag = 					2600;
const MessageT 							msg_TestWindow_Grow = 					2700;
const MessageT 							msg_TestWindow_SetTitle = 			2700;


class	CTinselTestWindow
	 : public LWindow,
		 public LListener,
		 public LBroadcaster {
public:
	enum { class_ID = 'Twnd' };

	static CTinselTestWindow*	CreateTinselTestWindow(ResIDT inWindowID,
								LCommander *inSuperCommander);
	static CTinselTestWindow*	CreateTinselTestWindowStream(LStream *inStream);
	
	static void GetDefaultGlobalRects(
				GDHandle inDevice, 
				Rect* outLeftRect, 
				Rect* outRightRect);
	
		static CTinselTestWindow*
	GetLeftWindow()
	{
		return sLeftWindow;
	}
	
		static CTinselTestWindow*
	GetRightWindow()
	{
		return sRightWindow;
	}
	
					CTinselTestWindow();
					CTinselTestWindow(const SWindowInfo &inWindowInfo);
					CTinselTestWindow(ResIDT inWINDid, Uint32 inAttributes,
								LCommander *inSuperCommander);
					CTinselTestWindow(LStream *inStream);
	
	void ListenToMessage(MessageT inMessage, void* ioParam);
	void ClickInDrag(const EventRecord	&inMacEvent);
	void ClickInGrow(const EventRecord	&inMacEvent);
	void DrawSizeBox();

	virtual Boolean			ObeyCommand(
								CommandT	inCommand,
								void		*ioParam = nil);
								
	virtual void FindCommandStatus(
		CommandT	inCommand,
		Boolean		&outEnabled,
		Boolean		&outUsesMark,
		Char16		&outMark,
		Str255		outName);
	
	Boolean AskSaveAs();
	void DoAESave(
		FSSpec&	inFileSpec,
		OSType	inFileType);
		
	void Clear();
	void SaveTestOutput();
	
		LGWorld*
	GetGWorld()
	{
		return mGWorld;
	}
	
protected:
	static CTinselTestWindow* sLeftWindow;
	static CTinselTestWindow* sRightWindow;
	
	LGWorld* mGWorld;

	virtual void DrawSelf();
	void InitTestWindow();
};