// ===========================================================================
// Drive3D.r.h
// ===========================================================================
// 
// This file contains all the constant and enum definitions from Drive3D
// which have been converted to #define's.  Everything else from the Drive3D.h
// has been removed, so this file can be included in rez source code. 


#define 	kQAPixel_Alpha1		  0		/* 1 bit/pixel alpha */
#define 	kQAPixel_RGB16		  1		/* 16 bit/pixel, R=14:10, G=9:5, B=4:0 */
#define 	kQAPixel_ARGB16		  2		/* 16 bit/pixel, A=15, R=14:10, G=9:5, B=4:0 */
#define 	kQAPixel_RGB32		  3		/* 32 bit/pixel, R=23:16, G=15:8, B=7:0 */
#define 	kQAPixel_ARGB32		  4			/* 32 bit/pixel, A=31:24, R=23:16, G=15:8, B=7:0 */
#define 	kQAPixel_CL4		  5
#define 	kQAPixel_CL8		  6

#define 	kQADeviceMemory		  0		/* Memory draw context */
#define 	kQADeviceGDevice	  1		/* Macintosh GDevice draw context */
#define 	kQADeviceWindows	  2			/* Windows xxx draw context */


#define 	kQAClipRgn			  0			/* Macintosh clipRgn with serial number */


#define 	kQANoErr				  0				/* No error */
#define 	kQAError				  1				/* Generic error flag */
#define 	kQAOutOfMemory			  2				/* Insufficient memory */
#define 	kQANotSupported			  3				/* Requested feature is not supported */
#define 	kQAOutOfDate			  4				/* A newer drawing engine was registered */
#define 	kQAParamErr				  5				/* Error in passed parameters */
#define 	kQAGestaltUnknown		  6					/* Requested gestalt type isn't available */


#define 	kQATag_ZFunction				  0
#define 	kQATag_Antialias				  8
#define 	kQATag_Blend					  9
#define 	kQATag_PerspectiveZ				  10
#define 	kQATag_TextureFilter			  11
#define 	kQATag_TextureOp				  12
#define 	kQATagGL_DrawBuffer				  100
#define 	kQATagGL_TextureWrapU			  101
#define 	kQATagGL_TextureWrapV			  102
#define 	kQATagGL_TextureMagFilter		  103
#define 	kQATagGL_TextureMinFilter		  104
#define 	kQATagGL_ScissorXMin			  105
#define 	kQATagGL_ScissorYMin			  106
#define 	kQATagGL_ScissorXMax			  107
#define 	kQATagGL_ScissorYMax			  108
#define 	kQATagGL_BlendSrc				  109
#define 	kQATagGL_BlendDst				  110
#define 	kQATagGL_LinePattern			  111
#define 	kQATagGL_AreaPattern0			  117
#define 	kQATagGL_AreaPattern31			  148
#define 	kQATag_EngineSpecific_Minimum	  1000

#define 	kQATag_Texture					  13

#define 	kQATag_ColorBG_a				  1
#define 	kQATag_ColorBG_r				  2
#define 	kQATag_ColorBG_g				  3
#define 	kQATag_ColorBG_b				  4
#define 	kQATag_Width					  5
#define 	kQATag_ZMinOffset				  6
#define 	kQATag_ZMinScale				  7
#define 	kQATagGL_DepthBG				  112
#define 	kQATagGL_TextureBorder_a		  113
#define 	kQATagGL_TextureBorder_r		  114
#define 	kQATagGL_TextureBorder_g		  115
#define 	kQATagGL_TextureBorder_b		  116

#define kQAZFunction_None			0	/* Z is neither tested nor written (same as no Z buffer) */
#define kQAZFunction_LT				1	/* Znew < Zbuffer is visible */
#define kQAZFunction_EQ				2	/* Znew == Zbuffer is visible */
#define kQAZFunction_LE				3	/* Znew <= Zbuffer is visible */
#define kQAZFunction_GT				4	/* Znew > Zbuffer is visible */
#define kQAZFunction_NE				5	/* Znew != Zbuffer is visible */
#define kQAZFunction_GE				6	/* Znew >= Zbuffer is visible */
#define kQAZFunction_True			7	/* Znew is always visible */

#define kQAMaxWidth					128.0

#define kQAAntiAlias_Off			0
#define kQAAntiAlias_Fast			1
#define kQAAntiAlias_Mid			2
#define kQAAntiAlias_Best			3

#define kQABlend_PreMultiply		0
#define kQABlend_Interpolate		1
#define kQABlend_OpenGL				2

#define kQAPerspectiveZ_Off			0	/* Use Z for hidden surface removal */
#define kQAPerspectiveZ_On			1	/* Use InvW for hidden surface removal */

#define kQATextureFilter_Fast		0
#define kQATextureFilter_Mid		1
#define kQATextureFilter_Best		2

#define kQATextureOp_None		0				/* Default texture mapping mode */
#define kQATextureOp_Modulate	(1 << 0)		/* Modulate texture color with kd_r/g/b */
#define kQATextureOp_Highlight	(1 << 1)		/* Add highlight value ks_r/g/b */
#define kQATextureOp_Decal		(1 << 2)		/* When texture alpha == 0, use rgb instead */
#define kQATextureOp_Shrink		(1 << 3)		/* This is a non-wrapping texture, so the

#define kQAGL_Repeat				0
#define kQAGL_Clamp					1

#define kQAGL_SourceBlend_XXX		0

#define kQAGL_DestBlend_XXX			0

#define kQAGL_DrawBuffer_None		0
#define kQAGL_DrawBuffer_FrontLeft	(1<<0)
#define kQAGL_DrawBuffer_FrontRight	(1<<1)
#define kQAGL_DrawBuffer_BackLeft	(1<<2)
#define kQAGL_DrawBuffer_BackRight	(1<<3)
#define kQAGL_DrawBuffer_Front		(kQAGL_DrawBuffer_FrontLeft | kQAGL_DrawBuffer_FrontRight)
#define kQAGL_DrawBuffer_Back		(kQAGL_DrawBuffer_BackLeft | kQAGL_DrawBuffer_BackRight)



#define 	kQAVertexMode_Point				  0		/* Draw nVertices points */
#define 	kQAVertexMode_Line				  1		/* Draw nVertices/2 line segments */
#define 	kQAVertexMode_Polyline			  2		/* Draw nVertices-1 connected line segments */
#define 	kQAVertexMode_Tri				  3		/* Draw nVertices/3 triangles */
#define 	kQAVertexMode_Strip				  4		/* Draw nVertices-2 triangles as a strip */
#define 	kQAVertexMode_Fan				  5			/* Draw nVertices-2 triangles as a fan from v0 */


#define 	kQAGestalt_OptionalFeatures		  0		/* Mask of one or more kQAOptional_xxx */
#define 	kQAGestalt_FastFeatures			  1		/* Mask of one or more kQAFast_xxx */
#define 	kQAGestalt_VendorID				  2		/* Vendor ID */
#define 	kQAGestalt_EngineID				  3		/* Engine ID */
#define 	kQAGestalt_Revision				  4		/* Revision number of this engine */
#define 	kQAGestalt_ASCIINameLength		  5		/* strlen (asciiName) */
#define 	kQAGestalt_ASCIIName			  6			/* Causes strcpy (response, asciiName) */


#define	kQATriFlags_None			0			/* No flags (triangle is front-facing or don't care) */
#define kQATriFlags_Backfacing		(1 << 0)	/* Triangle is back-facing */


#define	kQATexture_None				0			/* No flags */
#define kQATexture_Lock				(1<<0)		/* Don't swap this texture out */
#define kQATexture_Mipmap			(1<<1)		/* This texture is mipmapped */


#define	kQABitmap_None				0			/* No flags */
#define kQABitmap_Lock				(1<<1)		/* Don't swap this bitmap out */


#define kQAContext_None				0			/* No flags */
#define kQAContext_NoZBuffer		(1 << 0)	/* No hidden surface removal */
#define kQAContext_DeepZ			(1 << 1)	/* Hidden surface precision >= 24 bits */
#define kQAContext_DoubleBuffer		(1 << 2)	/* Double buffered window */
#define kQAContext_Cache			(1 << 3)	/* This is a cache context */


#define kQAOptional_None			0			/* No optional features */
#define kQAOptional_DeepZ			(1 << 0)	/* Hidden surface precision >= 24 bits */
#define kQAOptional_Texture			(1 << 1)	/* Texture mapping */
#define kQAOptional_TextureHQ		(1 << 2)	/* High quality texture (tri-linear mip or better) */
#define kQAOptional_TextureColor	(1 << 3)	/* Full color modulation and highlight of textures */
#define kQAOptional_Blend			(1 << 4)	/* Transparency blending of RGB */
#define kQAOptional_BlendAlpha		(1 << 5)	/* Transparency blending includes alpha channel */
#define kQAOptional_Antialias		(1 << 6)	/* Antialiased rendering */
#define kQAOptional_ZSorted			(1 << 7)	/* Z sorted rendering (for transparency, etc.) */
#define kQAOptional_PerspectiveZ	(1 << 8)	/* Hidden surface removal using InvW instead of Z */
#define kQAOptional_OpenGL			(1 << 9)	/* Extended rasterization features for OpenGL */
#define kQAOptional_NoClear			(1 << 10)	/* This drawing engine doesn't clear before drawing */


#define kQAFast_None				0			/* No accelerated features */
#define kQAFast_Line				(1 << 0)	/* Line drawing */
#define kQAFast_Gouraud				(1 << 1)	/* Gouraud shaded triangles */
#define kQAFast_Texture				(1 << 2)	/* Texture mapped triangles */
#define kQAFast_TextureHQ			(1 << 3)	/* High quality texture (tri-linear mip or better) */
#define kQAFast_Blend				(1 << 4)	/* Transparency blending */
#define kQAFast_Antialiasing		(1 << 5)	/* Antialiased rendering */
#define kQAFast_ZSorted				(1 << 6)	/* Z sorted rendering of non-opaque objects */


#define 	kQAVersion_Prerelease		  0
#define 	kQAVersion_1_0				  1

