// ===========================================================================
// CCommandButton.cp
// ===========================================================================


#include <LCommander.h>

#include "CCommandButton.h"


const long	simulateClick_Duration	= 8;	// Keep hot spot hilited for
											// this many ticks when simulating
											// a click (HIG p205)
											
											
// ===========================================================================
	CCommandButton*
CCommandButton::CreateCommandButtonStream(
	LStream	*inStream)
{
	return (new CCommandButton(inStream));
}


// ===========================================================================
CCommandButton::CCommandButton(
	LStream	*inStream)
		: LStdButton(inStream)
{
}


// ===========================================================================
//		 HotSpotResult
// ===========================================================================
	void
CCommandButton::HotSpotResult(
	Int16	/* inHotSpot */)
{
	LCommander::GetTarget()->ObeyCommand(mValueMessage);
}


// ===========================================================================
//		 HiliteHotSpot
// ===========================================================================
//	Simulate a mouse click within a HotSpot
//
//	Provide the same visual feedback and result as if the user clicked
//	inside a particular HotSpot of a Control. This function may be used
//	to implement keystroke equivalents for Control clicks.
	void
CCommandButton::HiliteHotSpot()
{
	if (IsEnabled()) {
		long	ticks;
		
		HotSpotAction(kControlButtonPart, true, false);	// Do action for click inside
		::Delay(simulateClick_Duration, &ticks);// Wait so user can see effect
		HotSpotAction(kControlButtonPart, false, true);	// Undo visual effect
		
		// we don't perform the result of the click here. that's 
		// SimulateHotSpotClick's job.
	}
}
