// ===========================================================================
//	CSmartSingleDoc.cp
// ===========================================================================


#include <UWindows.h>

#include "CSmartSingleDoc.h"


// ===========================================================================
//		 CSmartSingleDoc
// ===========================================================================
//	Default constructor
//

CSmartSingleDoc::CSmartSingleDoc()
	: LSingleDoc()
{
}


// ===========================================================================
//		 CSmartSingleDoc(LCommander*)
// ===========================================================================
//	Constructor, specifying SuperCommander

CSmartSingleDoc::CSmartSingleDoc(LCommander	*inSuper)
	: LSingleDoc(inSuper)
{
}


// ===========================================================================
	void
CSmartSingleDoc::AttemptQuitSelf(Boolean	inRecordIt)
{
	if (mWindow != nil && IsModified()) {
			// we're being closed, so bring our window to the front, so that if 
			// a "Save before quitting?" alert appears, our window will be
			// frontmost and the alert will be positioned on top of it.  we
			// call UDesktop::SelectDeskWindow instead of LWindow->Select
			// since we don't want this to be recorded as an AppleEvent.
		UDesktop::SelectDeskWindow(mWindow);
	}

Str255 title;
mWindow->GetDescriptor(title);
SignalPStr_(title);
	
		// let our super class do the actual closing
	inherited::AttemptQuitSelf(inRecordIt);
}


// ===========================================================================
	Int16
CSmartSingleDoc::GetWindowIndex()
{
	if (mWindow == nil) {
			// this doc doesn't have a window, so retrun 0, which is returned
			// by FindWindowIndex() when it can't find a window
		return 0;
	}
	
	WindowPtr windowP = (WindowPtr) mWindow->GetMacPort();
	
	return UWindows::FindWindowIndex(windowP);
}
