/*****************************************************************************\

	S3Debugging.cp

	Copyright (C) 1995 Apple Computer, Inc.  All rights reserved.

\*****************************************************************************/

/*=========================================================================*\
	Includes
\*=========================================================================*/

#include <UDebugging.h>
#include <stdio.h>

#include "S3TestSystem.h"
#include "StringConversion.h"

/*=========================================================================*\
	_S3AssertFunc
	
	Wrapper so outsiders (people writing tests) can assert things...
\*=========================================================================*/

void _S3AssertFunc(
	char*		inMessage,
	char*		inFile,
	long		inLine)
{
	Str255 messagePString;
	Str255 filePString;
	
	S3CtoPString(inMessage, messagePString);
	S3CtoPString(inFile, filePString);
	
	if (gDebugSignal == debugAction_Alert) {					
		UDebugging::AlertSignalAt(messagePString, filePString, inLine);		
	} else if (gDebugSignal == debugAction_LowLevelDebugger) {	
		BreakStrToLowLevelDebugger_(messagePString);						
	} else if (gDebugSignal == debugAction_SourceDebugger) {	
		BreakToSourceDebugger_();								
	}															
}
	

