// ===========================================================================
//	StringConversion.cp
// ===========================================================================


//#include <UDebugging.h>

#include <string.h>

#include "StringConversion.h"


#define kMaxPStringLength 255


// ===========================================================================
	void
S3CtoPString(char* ioCString, Int16 inMaxLength)
{
	Assert_(ioCString);
	
		// if inMaxLength was explicitly set, use it as the max length of the 
		// Pascal string; otherwise it will be 0, so so use the C string's length
	Int16 PStringLength;
	if (inMaxLength > 0)  {
		PStringLength = inMaxLength;
	} else {
		PStringLength = strlen(ioCString);
	}
	
		// make sure the Pascal string's length is less than the max (255)
	PStringLength = (PStringLength < kMaxPStringLength) ? PStringLength : kMaxPStringLength;
	
		// convert the C string in place
	::BlockMoveData(ioCString, &ioCString[1], PStringLength);
	ioCString[0] = PStringLength;
}


// ===========================================================================
	void
S3CtoPString(const char* inCString, StringPtr outPString, Int16 inMaxLength)
{
	Assert_(inCString && outPString);
	
		// if inMaxLength was explicitly set, use it as the max length of the 
		// Pascal string; otherwise it will be 0, so so use the C string's length
	Int16 PStringLength;
	if (inMaxLength > 0)  {
		PStringLength = inMaxLength;
	} else {
		PStringLength = strlen(inCString);
	}
	
		// make sure the Pascal string's length is less than the max (255)
	PStringLength = (PStringLength < kMaxPStringLength) ? PStringLength : kMaxPStringLength;
	
		 // put the converted C string in outPString
	::BlockMoveData(inCString, &outPString[1], PStringLength);
	outPString[0] = PStringLength;
}


// ===========================================================================
	void
S3PtoCString(StringPtr ioPString, unsigned short inMaxLength)
{
	Assert_(ioPString);
	
		// if inMaxLength was explicitly set, use it as the max length of the 
		// C string; otherwise it will be 0, so so use the Pascal string's length
	Int16 CStringLength;
	if (inMaxLength > 0)  {
		CStringLength = inMaxLength;
	} else {
		CStringLength = StrLength(ioPString);
	}
	
		// convert the P string in place
	::BlockMoveData(&ioPString[1], ioPString, CStringLength);
	ioPString[CStringLength] = '\0';
}


// ===========================================================================
	void
S3PtoCString(ConstStr255Param inPString, char* outCString, unsigned short inMaxLength)
{
	Assert_(inPString && outCString);
	
		// if inMaxLength was explicitly set, use it as the max length of the 
		// C string; otherwise it will be 0, so so use the Pascal string's length
	Int16 CStringLength;
	if (inMaxLength > 0)  {
		CStringLength = inMaxLength;
	} else {
		CStringLength = StrLength(inPString);
	}
	
		 // put the converted C string in outCString
	::BlockMoveData(inPString, outCString, CStringLength);
	outCString[CStringLength] = '\0';
}
