/*****************************************************************************\

	S3TestSystem.h

	Interfaces for a test tool to the Sneak3View test system registration,
	and to the Drive3D.h wrapper routines which route QA calls to the 
	mirrored engines.

	Copyright (C) 1995 Apple Computer, Inc.  All rights reserved.

\*****************************************************************************/
#pragma once

/*=========================================================================*\
	Includes
\*=========================================================================*/
#include "RAVE.h"
#include "S3TestInfo.h"

#ifdef __cplusplus
extern "C" {
#endif

/*=========================================================================*\
	Constants
\*=========================================================================*/

#define kS3Divider_Equal "==============================================================================\r"
#define kS3Divider_Hyphen "------------------------------------------------------------------------------\r"

/*=========================================================================*\
	Types
\*=========================================================================*/

/*=========================================================================*\
	TT Utility Routines
\*=========================================================================*/

void S3TestUtil_RandomVGouraud (
	S3tTestInfo			*testInfo,
	TQAVGouraud			*v);

void S3TestUtil_RandomVTexture(
	S3tTestInfo			*testInfo,
	TQAVTexture			*v);

void S3TestUtil_RandomAlphaVGouraud (
	S3tTestInfo			*testInfo,
	TQAVGouraud			*v);

void S3TestUtil_RandomAlphaVTexture (
	S3tTestInfo			*testInfo,
	TQAVTexture			*v);

void S3TestUtil_DrawRandomTriGouraud(
	S3tTestInfo			*testInfo);

void S3TestUtil_DrawRandomTriTexture(
	S3tTestInfo			*testInfo);

char *S3TestUtil_TQAErrorToString(
	TQAError		error);

float S3TestUtil_RandomFloat(void);

void S3TestUtil_ResetRandomSeed(void);

#ifdef __cplusplus
}
#endif

