// ===========================================================================
// S3Utilities.h
// ===========================================================================


#include <Types.h>
#include <PP_Types.h>

#include "RAVE.h"
#include "S3TestInfo.h"


#ifdef __cplusplus
extern "C" {
#endif
	 

#define kWindowScreenPercentage 	0.75
#define kPICTFileHeaderSize 			512


TQAEngine* 			S3GetEngineByName(
									char* 						inEngineName);

Boolean					S3GetEngineName(
									const TQAEngine*	inEngine, 
									char* 						outEngineName, 
									long 							inEngineNameLength);
																	
Boolean					S3EngineSupportsDevice(
									const TQAEngine*	inEngine, 
									const TQADevice*	inDevice);

unsigned long 	S3MicrosecondCount(void);

unsigned long 	S3ElapsedMicroseconds(
									unsigned long 		inLastCount);

GDHandle				S3GetDeviceFromRect(
									const Rect*				inRect, 
									Boolean* 					outIsOnOneDevice);
									
GDHandle 				S3GetDeepestScreen(void);

void 						S3GetDefaultGlobalRects(
									const GDHandle		inDevice, 
									Rect* 						outLeftRect, 
									Rect* 						outRightRect);

void 						S3GlobalToDeviceLocal(
									const GDHandle		inDevice,
									Rect* 						ioRect);

Boolean					S3IsPowerOf2(
									unsigned long 		inNumber,
									unsigned short* 	outPower);

void						S3MakeBlackTransparent(
									long 							inWidth,
									long 							inHeight,
									long 							inRowBytes,
									void* 						inPixMap,
									TQAImagePixelType inPixelType);
									
Boolean 				S3GetPICTFileSpec(
									FSSpec* 					outFSSpec);
									
PicHandle				S3GetPICTFromFile(
									const FSSpec*			inFSSpec);

PicHandle				S3GetNearbyPICT(
									S3tTestInfo* 			inTestInfo, 
									char* 						inFileName);
									
void						S3GetAppFileSpec(
									FSSpec* 					outFSSpec);
									
#ifdef __cplusplus
}
#endif
