/*****************************************************************************\

	S3TestRegister.c

	Hook in here.
	
	Copyright (C) 1995 Apple Computer, Inc.  All rights reserved.

\*****************************************************************************/

/*=========================================================================*\
	Includes
\*=========================================================================*/
#include "S3TestSystem.h"

/*=========================================================================*\
	Tests
\*=========================================================================*/

extern void S3TimingTests_Register(void);
extern void S3TextureBitmapTests_Register(void);
extern void S3RandomTests_Register(void);
extern void S3MoreTests_Register(void);
extern void S3EvenMoreTests_Register(void);
extern void S3GameTest_Register(void);


/*=========================================================================*\
	Test Registration
\*=========================================================================*/

/*=========================================================================*\
	S3Test_Init
\*=========================================================================*/
void S3Test_Init(
	void)
{
	S3RandomTests_Register();

		// add a divider to the list of tests by passing nil
	S3Test_Register("",								kS3Prereq_None, nil);
	
	S3TextureBitmapTests_Register();	
	
		// add a divider to the list of tests by passing nil
	S3Test_Register("",								kS3Prereq_None, nil);
	
	S3GameTest_Register();
	
		// add a divider to the list of tests by passing nil
	S3Test_Register("",								kS3Prereq_None, nil);
	
	S3TimingTests_Register();
	
		// add a divider to the list of tests by passing nil
	S3Test_Register("",								kS3Prereq_None, nil);
	
	S3MoreTests_Register();
	
	S3Test_Register("",								kS3Prereq_None, nil);

	S3EvenMoreTests_Register();
}

/*=========================================================================*\
	S3Test_Exit
\*=========================================================================*/
void S3Test_Exit(
	void)
{

}
