// ===========================================================================
//	
// 	GSColorTable.h
//	
//	Copyright (C) 1996 Apple Computer, Inc.  All rights reserved.
//
// ===========================================================================


#ifndef _GSColorTable_h
#define _GSColorTable_h


// ===========================================================================
//	Includes
// ===========================================================================

#include "RAVE.h"
#include "GSError.h"

#if (kQAPlatform == kQAMacOS)
	#include <QuickDraw.h>
#endif


#ifdef __cplusplus
extern "C" {
#endif


// ===========================================================================
//	Types
// ===========================================================================

typedef struct TGSColorTable 	TGSColorTable;


// ===========================================================================
//	Prototypes
// ===========================================================================

	TGSError
GSColorTable_New(
	TGSColorTable**			inColorTable);
	
#if (kQAPlatform == kQAMacOS)

	TGSError
GSColorTable_NewFromMacColorTable(
	TGSColorTable**			inColorTable,
	TQAColorTableType	 	inColorTableType,
	CTabHandle				inMacColorTableH);
	
#endif

	void
GSColorTable_Delete(
	TGSColorTable*			inColorTable);
	
	TGSError
GSColorTable_ChangeBrightness(
	TGSColorTable*			inColorTable,
	float					inBrightnessPercentage);
	
	void*
GSColorTable_GetData(
	TGSColorTable*			inColorTable);
	
	TQAColorTableType
GSColorTable_GetType(
	TGSColorTable*			inColorTable);


#ifdef __cplusplus
}
#endif


#endif // _GSColorTable_h
