// ===========================================================================
//	
// 	GSDrawInfo.h 
//	
//	Copyright (C) 1996 Apple Computer, Inc.  All rights reserved.
//
// ===========================================================================


#ifndef _GSDrawInfo_h
#define _GSDrawInfo_h


// ===========================================================================
//	Includes
// ===========================================================================

#include "RAVE.h"

#include "GSImage.h"


#ifdef __cplusplus
extern "C" {
#endif


// ===========================================================================
//	Types
// ===========================================================================

typedef struct TGSDrawInfo {	
	TQADrawContext*		mContext;
	TQARect				mContextRect;
	unsigned long		mContextFlags;
	TQAEngine*			mEngine;
	TQADevice			mDevice;
	TQAImagePixelType	mTextureFormat;
	unsigned long		mTextureFilter;
	unsigned long		mTextureOp;
	unsigned long		mTextureFlags;
	Boolean				mTextureDetach;
	Boolean				mTextureMakeMipMap;
	Boolean				mTextureMakeBlackTransparent;
	Boolean				mTextureUseTransparentIndex;
	TQAImagePixelType	mBitmapFormat;
	unsigned long		mBitmapFlags;
	Boolean				mBitmapDetach;
	Boolean				mBitmapMakeBlackTransparent;
	Boolean				mBitmapUseTransparentIndex;
} TGSDrawInfo;


#ifdef __cplusplus
}
#endif



#endif // _GSDrawInfo_h
