// ===========================================================================
//	
// 	GSError.h
//	
//	Copyright (C) 1996 Apple Computer, Inc.  All rights reserved.
//
// ===========================================================================


#ifndef _GSError_h
#define _GSError_h


// ===========================================================================
// 	Error Macros
// ===========================================================================

#ifdef kGSDebug
	void GSError(const char* inMessage);

	#define GSString_(x) GSPound_(x)
	#define GSPound_(x) #x
	
	#define GSAssert_(test) 										\
		(test) ? (void) 0 :											\
			GSError(__FILE__ " (" GSString_(__LINE__) "): " #test)
#else
	#define GSAssert_(test)												
#endif


// ===========================================================================
//	Types
// ===========================================================================

typedef enum TGSError {
	kGSError_None,
	kGSError_General,
	kGSError_NotEnoughMemory,
	kGSError_FileNotFound,
	kGSError_FileSystem,
	kGSError_RAVE,
	kGSError_OS,
} TGSError;


#endif // _GSError_h
