// ===========================================================================
//	
// 	GSPicture.h
//	
//	Copyright (C) 1996 Apple Computer, Inc.  All rights reserved.
//
// ===========================================================================


#ifndef _GSPicture_h
#define _GSPicture_h


// ===========================================================================
//	Includes
// ===========================================================================

#include <stdio.h>

#if (kQAPlatform == kQAMacOS)
	#include <Files.h>
#endif

#include "RAVE.h"
#include "GSError.h"

#include "GSColorTable.h"

#ifdef __cplusplus
extern "C" {
#endif


// ===========================================================================
//	Types
// ===========================================================================

typedef struct TGSPicture 	TGSPicture;


// ===========================================================================
//	Prototypes
// ===========================================================================

	TGSError
GSPicture_New(
	TGSPicture**			inPicture);
	
	TGSError
GSPicture_NewFromPath(
	TGSPicture**			inPicture,
	TQAImagePixelType 		inPixelType,
	const char*				inPath);
	
	TGSError
GSPicture_NewFromFile(
	TGSPicture**			inPicture,
	TQAImagePixelType 		inPixelType,
	FILE*					inPictureFile);
	
	void
GSPicture_Delete(
	TGSPicture*				inPicture);

	long
GSPicture_GetWidth(
	TGSPicture*				inPicture);
	
	long
GSPicture_GetHeight(
	TGSPicture*				inPicture);
	
	long
GSPicture_GetRowBytes(
	TGSPicture*				inPicture);
	
	void*
GSPicture_GetPixMap(
	TGSPicture*				inPicture);
	
	TQAImagePixelType
GSPicture_GetPixelType(
	TGSPicture*				inPicture);
	
	TGSColorTable*
GSPicture_GetColorTable(
	TGSPicture*				inPicture);


#ifdef __cplusplus
}
#endif


#endif // _GSPicture_h
