//
// Instance state information about the plugin.
//
// Used to hold per-instance information that
// youll need in the various functions in this file.
//

#ifndef _View3DMF_H_
#define _View3DMF_H_

#include "npapi.h"

struct _PluginInstance {
	NPWindow*		fWindow;				// the Netscape window for this instantiation
	uint16			fMode;					// NP_EMBED, NP_FULL, or NP_BACKGROUND

	Boolean 		fBusy;					// Are we loading?
	Handle			fBuffer;				// holds the 3DMF download
	int32			fBufferLength;			// Size of picture in bytes

	TQ3ViewObject	fView ;					// the view for the scene
	TQ3GroupObject	fModel ;				// object in the scene being modelled
	TQ3StyleObject	fInterpolation ;		// interpolation style used when rendering
	TQ3StyleObject	fBackFacing ;			// whether to draw shapes that face away from the camera
	TQ3StyleObject	fFillStyle ;			// whether drawn as solid filled object or decomposed to components
	TQ3Matrix4x4	fRotation;				// the transform for the model
	TQ3Point3D		fGroupCenter ;			// the center of the group (for rotation) 
	float			fGroupScale	;			// scaling factor to apply before drawing

	Rect			fRect;
};

typedef struct _PluginInstance PluginInstance ;


#endif