/******************************************************************************
 **																			 **
 ** 	Module:		QD3DString.h 											 **
 ** 																		 **
 ** 																		 **
 ** 	Purpose:														   	 **
 ** 																		 **
 ** 																		 **
 ** 																		 **
 ** 	Copyright (C) 1994-1995 Apple Computer, Inc. All rights reserved.	 **
 ** 																		 **
 ** 																		 **
 *****************************************************************************/
#ifndef QD3DString_h
#define QD3DString_h

#if PRAGMA_ONCE
	#pragma once
#endif

#if defined(THINK_C) || defined(__SC__)
	#pragma options(!pack_enums, !align_arrays)
	#pragma SC options align=power
#elif defined(__MWERKS__)
	#pragma enumsalwaysint on
	#pragma align_array_members off
	#pragma options align=native
#elif defined(__PPCC__)
	#pragma options align=power
#elif defined(__xlc) || defined(__xlC) || defined(__xlC__) || defined(__XLC121__)
	#pragma options enum=int
#endif

#ifdef __cplusplus
extern "C" {
#endif /*  __cplusplus  */


/******************************************************************************
 **																			 **
 **								String Routines								 **
 **																			 **
 *****************************************************************************/
 
QD3D_EXPORT TQ3ObjectType Q3String_GetType(
	TQ3StringObject		stringObj);


/******************************************************************************
 **																			 **
 **						C String Routines									 **
 **																			 **
 *****************************************************************************/

QD3D_EXPORT TQ3StringObject Q3CString_New(
	const char				*string);

QD3D_EXPORT TQ3Status Q3CString_GetLength(
	TQ3StringObject			stringObj,
	unsigned long			*length);

QD3D_EXPORT TQ3Status Q3CString_SetString(
	TQ3StringObject			stringObj,
	const char				*string);

QD3D_EXPORT TQ3Status Q3CString_GetString(
	TQ3StringObject			stringObj,
	char					**string);

QD3D_EXPORT TQ3Status Q3CString_EmptyData(
	char					**string);

#ifdef __cplusplus
}
#endif /*  __cplusplus  */

#if defined(__MWERKS__)
	#pragma enumsalwaysint reset
#elif defined(__xlc) || defined(__xlC) || defined(__xlC__) || defined(__XLC121__)
	#pragma options enum=reset
#endif

#endif  /*  QD3DString_h  */
